> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Upsert Redirects

PUT https://api.bigcommerce.com/stores/{store_hash}/v3/storefront/redirects
Content-Type: application/json

Upserts new redirect data across all storefronts.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/content/store-content/redirects/upsert-redirects

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Content | modify | `store_v2_content` | | Content | read-only | `store_v2_content_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a list of 301RedirectUpsert.

- `list of 301RedirectUpsert`

## Response

### 201

Created

- `data` (list of 301RedirectRead, optional)
- `meta` (MetaPaginationObject, optional)

## Errors

### 422 Unprocessable Entity Error

Error response for batch PUT of redirects. Includes the errors for each reference ID.

- `status` (integer, optional) — The HTTP status code.
- `title` (string, optional) — The error title describing the particular error.
- `type` (string, optional)
- `instance` (string, optional)
- `errors` (DetailedErrors, optional)

## Types

### 301RedirectUpsert

Data necessary to create or update a redirect. If there’s a conflict on the from_path and site_id, the redirect will be overwritten with new data.

- `from_path` (string, required)
- `site_id` (integer, required)
- `to` (RedirectTo, optional)

### 301RedirectRead

Full detail of a Redirect, optionally including the full destination URL.

- `id` (integer, optional)
- `site_id` (integer, optional)
- `from_path` (string, optional)
- `to` (RedirectTo, optional)
- `to_url` (string, optional) — Full destination URL for the redirect. Must be explicitly included via URL parameter.

### MetaPaginationObject

- `pagination` (MetaPaginationObjectPagination, optional)

### DetailedErrors

### RedirectTo

- `type` (enum, optional)
  - Allowed values: `product`, `brand`, `category`, `page`, `post`, `url`
- `entity_id` (integer, optional)
- `url` (string, optional)

### MetaPaginationObjectPagination

- `total` (integer, optional)
- `count` (integer, optional)
- `per_page` (integer, optional)
- `current_page` (integer, optional)
- `total_pages` (integer, optional)
- `links` (MetaPaginationObjectPaginationLinks, optional)

### MetaPaginationObjectPaginationLinks

- `next` (string, optional)
- `current` (string, optional)

## Examples

**Request**

```json
[
  {
    "from_path": "/old-url/",
    "site_id": 1
  }
]
```

**Response**

```json
{
  "data": [
    {
      "id": 1,
      "site_id": 1,
      "from_path": "/old-url",
      "to": {
        "type": "product",
        "entity_id": 1,
        "url": "/new-url/"
      },
      "to_url": "https://store-domain.com/new-url"
    }
  ],
  "meta": {
    "pagination": {
      "total": 246,
      "count": 5,
      "per_page": 5,
      "current_page": 1,
      "total_pages": 50,
      "links": {
        "next": "?limit=5&page=2",
        "current": "?limit=5&page=1"
      }
    }
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects"

payload = [
    {
        "from_path": "/old-url/",
        "site_id": 1
    }
]
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects';
const options = {
  method: 'PUT',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '[{"from_path":"/old-url/","site_id":1}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects"

	payload := strings.NewReader("[\n  {\n    \"from_path\": \"/old-url/\",\n    \"site_id\": 1\n  }\n]")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"from_path\": \"/old-url/\",\n    \"site_id\": 1\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"from_path\": \"/old-url/\",\n    \"site_id\": 1\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects', [
  'body' => '[
  {
    "from_path": "/old-url/",
    "site_id": 1
  }
]',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects");
var request = new RestRequest(Method.PUT);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"from_path\": \"/old-url/\",\n    \"site_id\": 1\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "from_path": "/old-url/",
    "site_id": 1
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/storefront/redirects")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```